/*
 * Copyright (c) 2008 WonderMedia Technologies, Inc. All Rights Reserved.
 *
 * This PROPRIETARY SOFTWARE is the property of WonderMedia Technologies, Inc.
 * and may contain trade secrets and/or other confidential information of
 * WonderMedia Technologies, Inc. This file shall not be disclosed to any third
 * party, in whole or in part, without prior written consent of WonderMedia.
 *
 * THIS PROPRIETARY SOFTWARE AND ANY RELATED DOCUMENTATION ARE PROVIDED AS IS,
 * WITH ALL FAULTS, AND WITHOUT WARRANTY OF ANY KIND EITHER EXPRESS OR IMPLIED,
 * AND WonderMedia TECHNOLOGIES, INC. DISCLAIMS ALL EXPRESS OR IMPLIED WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, QUIET ENJOYMENT OR
 * NON-INFRINGEMENT.
 *
 * Revision History:
 * -------------------------------------------------------------------------------
 *
 */

#ifndef _CHIPTOP_H_
#define _CHIPTOP_H_

#define IN
#define OUT
#define IO

#define true    1
#define false   0
#define NULL    0

typedef unsigned char  uchar;
typedef unsigned int   uint;
typedef unsigned short ushort;
typedef unsigned long  ulong;
typedef unsigned long	 u32;
typedef unsigned short u16;
typedef unsigned char  u8;
typedef unsigned int   err_no_t ;

/*
 * Internal APB Slaves Memory Address Map
 */
#define BA_MC3           0xD8000000	/* DDR/DDR2 Memory Controller Configuration */
#define BA_MSC           0xD800B000	/* MemoryStick Controller Base Address */
#define	BA_MSCDMA        0xD800B100	/* MemoryStick Controller DMA Base Address */
#define BA_DMA           0xD8001000 /* system dma Base Address */
#define BA_RTC           0xD8100000	/* RTC Base Address */
#define BA_GPIO          0xD8110000	/* GPIO Base Address */
#define BA_SCC           0xD8120000	/* System Configuration Control Base Address */
#define BA_PMC           0xD8130000	/* Power Management Control Base Address */
#define BA_IC            0xD8140000	/* Interrupt Controller Base Address */
#define BA_UART0         0xD8200000	/* UART0 Base Address */
#define BA_UART1         0xD8210000	/* UART1 Base Address */
#define BA_SPI           0xD8240000	/* SPI Base Address */
#define BA_I2C           0xD8290000	/* I2C Base Address */
#define BA_PATAHC        0xD8008000 /* PATA HC Base Address */
#define BA_PATAREG       0xD8008270 /* PATA Data /Conmmand Base Address */
#define BA_PATASG        0xD8008500 /* PATA SG Base Address */
#define BA_PATAHC_PCI    0xD8008100 /* PATA PCI Base Address */
#define BA_PATACSREG     0xD8008376 /* PATA Control/Status Base Address */
/* USB Host Controller (UHCI & EHCI) */
/* #define BA_USB           0xD8007000 // USB CPAI Register Base Address */
#define BA_EHCI_PCI      0xD8007800 /* USB 2.0 EHCI USB Host Configuration Base Address */
#define BA_EHCI_REG      0xD8007900 /* USB 2.0 EHCI USB Host Register Base Address */
#define BA_UHCI_PCI      0xD8007A00 /* USB 1.1 UHCI USB Host Configuration Base Address */
#define BA_UHCI_REG      0xD8007B00 /* USB 1.1 UHCI USB Host Register Base Address */
#define BA_CFC           0xD800C000 /* CFC Base Address */
#define BA_DMACFC        0xD800C100 /* CFC Dma Base Address */

#define BA_PCISATAREG    0xC0000AF0
#define BA_PCISATAREG2   0xC0000A70
#define BA_PCIPATAREG    0xC00001F0
#define BA_PCISATACSREG  0xC0000AFA
#define BA_PCISATACSREG2 0xC0000A7A
#define BA_PCIPATACSREG  0xC00001FA
#define BA_PCISATASG     0xC000CC00
#define BA_PCIPATASG     0xC000CC10

/* Public functions */

#endif	/* _CHIPTOP_H_ */
