
#include <common.h>
#include <command.h>
#include <asm/arch/common_def.h>
#include "wmt_pmc.h"

#define PMHC_HIBERNATE 0x05
#define REG_SET32(addr,val)    (*(volatile unsigned int *)(addr)) = val
#define REG_GET32(addr)        (*(volatile unsigned int *)(addr))

void __inline__ wait_ms(unsigned long ms)
{
	while(ms-->0)
		udelay(1000);
}

static void wmt_power_off(void)
{
printf("wmt_power_off\n");
#if 1 /*fan*/
    wait_ms(100);
   // local_irq_disable();			// __Noodels__: is that OK?

    /*
     * Set scratchpad to zero, just in case it is used as a restart
     * address by the bootloader. Since PB_RESUME button has been
     * set to be one of the wakeup sources, clean the resume address
     * will cause zacboot to issue a SW_RESET, for design a behavior
     * to let PB_RESUME button be a power on button.
     *
     * Also force to disable watchdog timer, if it has been enabled.
     */
    HSP0_VAL = 0;
    OSTW_VAL &= ~OSTW_WE;

    /*
     * Well, I cannot power-off myself,
     * so try to enter power-off suspend mode.
     */
    PMHC_VAL = PMHC_HIBERNATE;
    asm("mcr%? p15, 0, %0, c7, c0, 4" : : "r" (0));		/* Force ARM to idle mode*/
#endif
}

void wmt_check_s_botton(int time)
{
	int i = 0, c_time=time;

	if(time<=0){
		return;
	}else if(time>5){
		c_time = 5;
	}

	// init the soft bottom
	REG_SET32(0xd8130054, REG_GET32(0xd8130054)|BIT0);

	//loop to detect if the soft buttom still be press
	// __Noodles__: because from power up to involve this function need
	//				some times. So adjust 1000 to 750.
	while(i<c_time*100){
		if(REG_GET32(0xd8130014)&BIT14){
			REG_SET32(0xd8130014, REG_GET32(0xd8130014)|BIT14);
			i+=10;
			wait_ms(10);
		}else{
			wmt_power_off();
			return;
		}
	}
}

int do_2sshutdown(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	wmt_check_s_botton(2);
}


int do_shutdown(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
	wmt_power_off();
}

U_BOOT_CMD(
    2mshutdown,    5,    1,    do_2sshutdown,
    "shutdown the board\n",
    "shutdown the board\n"
);


U_BOOT_CMD(
    shutdown,    5,    1,    do_shutdown,
    "shutdown the board\n",
    "shutdown the board\n"
);

