

#include <common.h>
#include <config.h>
#include <command.h>

#if (CONFIG_COMMANDS & CFG_CMD_DTT)

#include <dtt.h>

int do_dtt (cmd_tbl_t * cmdtp, int flag, int argc, char *argv[])
{
	int i;
	unsigned char sensors[] = CONFIG_DTT_SENSORS;

	/*
	 * Loop through sensors, read
	 * temperature, and output it.
	 */
	for (i = 0; i < sizeof (sensors); i++) {
		printf ("DTT%d: %i C\n", i + 1, dtt_get_temp (sensors[i]));
	}

	return 0;
}	/* do_dtt() */

/***************************************************/

U_BOOT_CMD(
	  dtt,	1,	1,	do_dtt,
	  "dtt     - Digital Thermometer and Themostat\n",
	  "        - Read temperature from digital thermometer and thermostat.\n"
);

#endif /* CONFIG_COMMANDS & CFG_CMD_DTT */
