
#include <common.h>
#include <command.h>
#include <linux/ctype.h>
#include "wmt_logo/minivgui.h"
#include "wmt_logo/logo_def.h"
#include "wmt_logo/wmt_mmap.h"
#include "wmt_logo/vpp_reg.h"
#include "wmt_logo/govrh_reg.h"
#include "wmt_logo/wmt_vpp.h"
//--> added by howayhuo on 20091111
#include <malloc.h>
#include <asm/arch/common_def.h>
//<--

//#define CHAR_WIDTH 8
//#define CHAR_HEIGHT 20  // 16

#define CHAR_WIDTH 12
#define CHAR_HEIGHT 22  // 16

static int text_x = 30, text_y = 30 - CHAR_HEIGHT;
// ------------------- Extern Variable ------------------------
extern parse_to_oal g_e2k;
extern unsigned int g_bmp_adr;
extern struct LCD_PANEL_INFO  lcd_info[12];
extern DWORD m_CurrentMode;

//-------------------- Extern Function -----------------------
extern int fill_parse_oal(void);
extern int wmt_graphic_init(void);
extern void mv_initPrimary(const mv_surface * s);
//extern void arm_memset(void * s, int c, size_t count);

int atoi(char *s) //added by howayhuo
{
    int i,n,sign;

    for(i=0;isspace(s[i]);i++) //հ׷
          ;
    sign=(s[i]=='-')?-1:1;
    if(s[i]=='+'||s[i]=='-')   //
          i++;
    for(n=0;isdigit(s[i]);i++)
          n=10*n+(s[i]-'0');  //ַת
    return sign *n;
}

int do_lcd_init(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
    mv_surface s;
    mv_Rect rect;
//--> added by howayhuo on 20091214
	unsigned int lcd_blt_level = 75;
	unsigned int lcd_blt_freq = 150;
//<-- end add
//--> added by howayhuo on 20100702
        char *op;
        int len;
//<-- end add
    parse_lcd_params();
    parse_pwm_params();

    g_lcd_init_ok = 0;  //LCD isn't initialized

    if (fill_parse_oal()) {
        printf("Get parameter failed\n");
        return -1;
    }

    if (wmt_graphic_init()) {
        printf("wmt_graphic_init failed\n");
        return -1;
    }
    s.width = g_e2k.CxScreen;
    s.height = g_e2k.CyScreen;
    s.startAddr = (char *)g_e2k.LCDPhysicalFrameBase;
    s.lineBytes = s.width*4;
    mv_initPrimary(&s);

    rect.left = 0;
    rect.top = 0;
    rect.right =  g_e2k.CxScreen;
    rect.bottom = g_e2k.CyScreen;
    mv_fillRect(&rect, mv_RGB2Color(0, 0, 0));

    if (g_e2k.bLCD_Panel_Enable)
    {
        govrh_set_dvo_enable(VPP_FLAG_ENABLE);//only enable LCD Panel
        if(g_dyn_pwm_param.valid == 1) {
                 if((g_dyn_pwm_param.no >= 0) && (g_dyn_pwm_param.no <= 3))
                    lcd_blt_enable(g_dyn_pwm_param.no, 1);
                 //else
                 //  PWM no isn't 0,1,2,3. Don't use PWM to control LCD backlight

        } else
            lcd_blt_enable(VPP_BLT_PWM_NUM, 1);

        if((g_dyn_lcd_param.valid == 1) && strlen(g_dyn_lcd_param.extra_reg_op) >= 10) {
            printf("Execute register operation for LCD:\n");
            excute_reg_op(g_dyn_lcd_param.extra_reg_op);
        }
        g_lcd_init_ok = 1; //LCD initialization is OK
    }

    text_x = 30;
    text_y = 30 - CHAR_HEIGHT;

//--> modified by howayhuo on 20091111
	//--> added by howayhuo on 20100702
	op = getenv("lcd_powerup");
       if(op)
       {
           len = strlen(op);
           if(len < 10) //the minimum string length of register operation is 10, for example: D8110004|1
               printf("Invalid lcd powerup operation: %s\n", op);
           else
           {
               printf("Execute lcd powerup operation:\n");
               excute_reg_op(op);
           }
	   udelay(50000);
       }

	//<-- end add
//if the 'pwmparam' environment is set and valid, the pwm no is decided by 'pwmparam'
        if(g_dyn_pwm_param.valid == 1)
        {
                    unsigned int pwm_clock;
                    pwm_clock = pwm_pclk();
                    printf("PWM%d input freq = %d Hz, output freq = %d Hz\n", \
                        g_dyn_pwm_param.no, pwm_clock, \
                        pwm_clock/(g_dyn_pwm_param.scalar * g_dyn_pwm_param.period));
                    pwm_set_period(g_dyn_pwm_param.no, g_dyn_pwm_param.period - 1);
                    pwm_set_duty(g_dyn_pwm_param.no, g_dyn_pwm_param.duty - 1);
                    pwm_set_control(g_dyn_pwm_param.no, (g_dyn_pwm_param.duty - 1)? 0x35:0x8);
                    pwm_set_gpio(g_dyn_pwm_param.no, g_dyn_pwm_param.duty - 1);
                    pwm_set_scalar(g_dyn_pwm_param.no, g_dyn_pwm_param.scalar - 1);
                    lcd_blt_enable(g_dyn_pwm_param.no,1);
                    printf("PWM%d register setting: scalar = %d, period = %d, duty = %d\n",  \
                        g_dyn_pwm_param.no,  \
                        REG32_VAL(PWM_SCALAR_REG_ADDR + (0x10 * g_dyn_pwm_param.no)) & 0x3ff, \
                        REG32_VAL(PWM_PERIOD_REG_ADDR + (0x10 * g_dyn_pwm_param.no)) & 0xfff, \
                        REG32_VAL(PWM_DUTY_REG_ADDR + (0x10 * g_dyn_pwm_param.no)) & 0xfff);
        }
        else
        {
                lcd_blt_set_level(VPP_BLT_PWM_NUM,lcd_blt_level);
                lcd_blt_set_freq(VPP_BLT_PWM_NUM,lcd_blt_freq);
                lcd_blt_enable(VPP_BLT_PWM_NUM,1);
                printf("PWM%d register setting: scalar = %d, period = %d, duty = %d\n",  \
                    VPP_BLT_PWM_NUM,  \
                    REG32_VAL(PWM_SCALAR_REG_ADDR + (0x10 * VPP_BLT_PWM_NUM)) & 0x3ff, \
                    REG32_VAL(PWM_PERIOD_REG_ADDR + (0x10 * VPP_BLT_PWM_NUM)) & 0xfff, \
                    REG32_VAL(PWM_DUTY_REG_ADDR + (0x10 * VPP_BLT_PWM_NUM)) & 0xfff);
        }
//<-- end modification
    printf("LCD init OK\n");
    return 0;
}

int do_clean_lcd(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
    mv_Rect rect;

    if(!g_lcd_init_ok)
    {
        printf("clean_lcd error: LCD isn't initialized, please run \"lcdinit\" first\n");
        return -1;
    }

    //arm_memset(s.startAddr, 0x00, s.width * s.height * s.lineBytes);
    //printf("g_e2k.LCDPhysicalFrameBase = 0x%x, g_e2k.CxScreen = %d, g_e2k.CyScreen = %d\n", g_e2k.LCDPhysicalFrameBase, g_e2k.CxScreen, g_e2k.CyScreen);
    rect.left = 0;
    rect.top = 0;
    rect.right =  g_e2k.CxScreen;
    rect.bottom = g_e2k.CyScreen;
    mv_fillRect(&rect, mv_RGB2Color(0, 0, 0));

    return 0;
}

int do_textout(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
{
    int  tmpx, tmpy;
    unsigned int rgb=0;
    char * text_first, *text_last;
    char r, g, b;
    int i,len, textLen;
    mv_Rect rect;
    char tmpbuf[200];

    if(!g_lcd_init_ok)
    {
        printf("do_textout error: LCD isn't initialized, please run \"lcdinit\" first\n");
        return -1;
    }

    switch (argc)
    {
        case 1:
        case 2:
        case 3:		/* use load_addr as default address */
        case 4:		/* use argument */
            printf("<ERROR> too few argument\n");
            printf ("Usage:\n%s\n", cmdtp->usage);
        return -1;

        default:
            //tmpx = simple_strtoul(argv[1], NULL, 10);
            //tmpy = simple_strtoul(argv[2], NULL, 10);
            tmpx = atoi(argv[1]);
            tmpy = atoi(argv[2]);

            //printf("tmpx=%d, tmpy=%d\n", tmpx,tmpy);

            if(tmpx >= 0)
                text_x = tmpx;

            if(tmpy >= 0)
                text_y = tmpy;
            else
                text_y = text_y + CHAR_HEIGHT;

            //printf("x=%d, y=%d\n", x, y);

            rgb = simple_strtoul(argv[argc -1], NULL, 16);

            text_first = argv[3];
            if(*text_first != '"')
            {
                printf("<ERROR> please specify the text begin with \" \n", *text_first);
                printf ("Usage:\n%s\n", cmdtp->usage);

                return -1;
            }

            text_last = argv[argc-2];
            while(*text_last != '\0')
                text_last++;

            if(*--text_last != '"')
            {
                printf("<ERROR> please specify the text end with \" \n", *text_last);
                printf ("Usage:\n%s\n", cmdtp->usage);
                return -1;
            }
        break;
    }
    len = 0;
    for(i=3; i<argc-1; i++)
    {
        printf("%s ", argv[i]);
        len += sprintf(tmpbuf+len, "%s ", argv[i]);
    }
    printf("\n");
    //if you input:
    //   drawtext 0 0 "aa bb cc" ff0000
    //then the tmpbuf is ["aa bb cc" ], it have redundant space at the end.
    tmpbuf[len -2] = '\0';    //ignore the last  'double quotation marks' and 'space'

    textLen = len - 3; // total len- ' start " ' (1 char) - 'space' (1 char) -' end " ' (1 char)
    rect.left = 0;
    rect.top = text_y;
    rect.right =  g_e2k.CxScreen;
    rect.bottom = text_y + CHAR_HEIGHT;
    mv_fillRect(&rect, mv_RGB2Color(0, 0, 0));

    r = (rgb >> 16) & 0xFF;
    g = (rgb >> 8)  & 0xFF;
    b = rgb & 0xFF;
    mv_textOut(text_x, text_y, tmpbuf+1, mv_RGB2Color(r,g,b));

    return 0;
}

U_BOOT_CMD(
	lcdinit,	2,	1,	do_lcd_init,
	"lcdinit - initialize LCD\n",
	"- initialize LCD\n"
      "Usage: lcdinit\n"
      "Before you execute 'lcdinit', you should set 'lcdparam' and 'pwmparam'\n"
      "if you don't set 'lcdparam' and 'pwmparam', U-Boot will use default LCD param and PWM param\n"
      "Default LCD param: 1,25000,8,800,480,48,40,40,3,29,13\n"
      "Default PWM param: 0,319,1000,750\n"
      "(1) lcdparam: version,pixclock,bpp,xres,yres,hpw,hbp,hfp,vpw,vbp,vfp,pwm_pcp,register(&|=)value\n"
	"comment:\n"
	"  version: Must set to 1\n"
	"  pixclock: LCD Clock (KHz)\n"
	"  bpp: 5: RGB565, 6: RGB666, 8:RGB888. It no effect in current verion and current version use fixed RGB888\n"
	"  xres: pels on X axis\n"
	"  yres: pels on Y axis\n"
	"  hpw: hsync pulse width\n"
	"  hbp: hsync back porch\n"
	"  hfp: hsync front porch\n"
	"  vpw:vsync pulse width\n"
	"  vbp: vsync back porch\n"
	"  vfp: vsync front porch\n"
	"  register(&|=)value: register&value or register|value or register=value\n"
	"(2) pwmparam: no,scalar,period,duty\n"
	"comment:\n"
	"no: PWM no. Range: 0 ~ 3. If PWM no is set to other value, It means don't use PWM to control LCD backlight\n"
	"scalar: PWM scalar. Range: 1 ~ 1024\n"
	"period: PWM period. Range: 1 ~ 4096\n"
	"duty: PWM duty. Range: 1 ~ 4096\n"
);

U_BOOT_CMD(
	cleanlcd,	1,	1,	do_clean_lcd,
	"cleanlcd - clean LCD screen\n",
	"- clean LCD screen\n"
       "Usage: cleanlcd\n"
);

U_BOOT_CMD(
	textout,	100,	5,	do_textout,
	"textout - show text to the screen \n"
	"textout x y \"str\" color\n"
	"color is 24bit Hex, R[23:16], G[15:8], B[7:0]\n"
	"for example: textout 0 0 \"hello world\" FFFFFF\n",
	"- show text to the screen \n"
	"usage: textout x y \"str\" color\n"
	"(x,y) is the coordinate. x, y are decimal. (x,y) default value is (30,30)\n"
	"if x < 0, the x coordinate is unchaged\n"
	"if y < 0, the y coordinate auto add 22 pixels to move to next line\n"
	"color is 24bit Hex, R[23:16], G[15:8], B[7:0]\n"
	"for example: textout 0 0 \"hello world\" FFFFFF\n"
	"             textout -1 -1 \"come on\" FF0000\n"
);

