
//#include <stdlib.h>

#if !defined(__UMEM_H__)
#include "umem.h"
#endif
#if !defined(__TETHER_H__)
#include "tether.h"
#endif
#if !defined(__ADAPTER_H__)
#include "adapter.h"
#endif
#if !defined(__PROTO_H__)
#include "proto.h"
#endif
#if !defined(__PPTEST_H__)
#include "pptest.h"
#endif
//#if !defined(__TMACRO_H__)
#include "tmacro.h"
//#endif




/*---------------------  Static Definitions -------------------------*/

/*---------------------  Static Classes  ----------------------------*/

/*---------------------  Static Variables  --------------------------*/

/*---------------------  Static Functions  --------------------------*/

/*---------------------  Export Variables  --------------------------*/


void GPPTvMakeEthernetPacket(PBYTE pbyPacket, PBYTE pbyDstAddr, 
                            PBYTE pbySrcAddr, WORD wType, 
                            PBYTE pbyData)
{
    PSEthernetHeader peh;

    peh = (PSEthernetHeader)pbyPacket;
    MEMvCopy(peh->abyDstAddr, pbyDstAddr, U_ETHER_ADDR_LEN);
    MEMvCopy(peh->abySrcAddr, pbySrcAddr, U_ETHER_ADDR_LEN);
    peh->wType = wType;
    // TBD....
    // we do not copy pbyData
    //UNREFERENCED_PARAMETER(pbyData); 
}


BOOL GPPTbListenAndAccept(PSAdapterInfo pAdapter, WORD wType)
{
    BOOL    bRetVal = FALSE;
    PBYTE   pbyPacket;
    UINT    uPktLen;

    PSEthernetHeader peh;
    PSProtocolBuffer pProBuf;

    pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];
	//printf("tmpt listen\n");
    if (GPRObProtocolReceive(pAdapter, &pbyPacket, &uPktLen)) {
        peh = (PSEthernetHeader)pbyPacket;

        if (peh->wType == wType) {
		//printf("tmpt ping\n");
            MEMvCopy(pProBuf->abyDstAddr, peh->abySrcAddr, U_ETHER_ADDR_LEN);
            bRetVal = TRUE;
        }

        GPROvProtocolReturnPacket(pAdapter);
    }

    return bRetVal;
}


void GPPTvMakeMasterBroadcastPacket(PBYTE pbyPacket, PBYTE pbySrcAddr, WORD wType)
{
    BYTE    abyBroadcastAddr[U_ETHER_ADDR_LEN];
    int     ii;

    PSPingPongData pPPD;

    for (ii = 0; ii < U_ETHER_ADDR_LEN; ii++)
        abyBroadcastAddr[ii] = 0xFF;

    pPPD = (PSPingPongData)(pbyPacket + sizeof(SEthernetHeader));
    MEMvCopy(pPPD->abyMasterEtherAddr, pbySrcAddr, U_ETHER_ADDR_LEN);

    GPPTvMakeEthernetPacket(pbyPacket, abyBroadcastAddr, pbySrcAddr, wType, (PBYTE)pPPD);
}


BOOL GPPTbMasterAdvertise(PSAdapterInfo pAdapter, WORD wType)
{
    PBYTE   pbyPacket;
    UINT    uPktLen;

    uPktLen = sizeof(SEthernetHeader) + sizeof(SPingPongData);
    pbyPacket = (PBYTE)malloc(uPktLen);

    if (pbyPacket == NULL)
        return FALSE;

    GPPTvMakeMasterBroadcastPacket(pbyPacket, pAdapter->abyEtherAddr, wType);

    if (!GPRObDriverSend(pAdapter, pbyPacket, uPktLen, 0))
        goto MAErr;

    free(pbyPacket);
    return TRUE;

MAErr:
    free(pbyPacket);
    return FALSE;
}


BOOL GPPTbMasterPing(PSAdapterInfo pAdapter)
{
    BYTE    abyPacket[2048];
    PBYTE   pbyPacket;
    UINT    uPktLen;

    PSPingPongData    pPPD;
    PSProtocolBuffer  pProBuf;


    pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];
    uPktLen = sizeof(SEthernetHeader) + sizeof(SPingPongData);
    //pbyPacket = (PBYTE)malloc(uPktLen);
    pbyPacket = (PBYTE)abyPacket;

    if (pbyPacket == NULL)
        return FALSE;

    pPPD = (PSPingPongData)(pbyPacket + sizeof(SEthernetHeader));
    pPPD->dwSerialNo = pProBuf->dwSerialNo;
    pProBuf->dwSerialNo++;
    GPPTvMakeEthernetPacket(pbyPacket, pProBuf->abyDstAddr, 
                           pAdapter->abyEtherAddr,
                           TYPE_PKT_PING_M, (PBYTE)pPPD);

    if (!GPRObDriverSend(pAdapter, pbyPacket, uPktLen, 0))
        goto MPErr;

    //free(pbyPacket);
    return TRUE;

MPErr:
    //free(pbyPacket);
    return FALSE;
}

extern int tmpt_rand();
BOOL GPPTbMasterPingEx(PSAdapterInfo pAdapter, UINT uPktLen, int iDataPat)
{
    BYTE    abyPacket[2048];
    PBYTE   pbyPacket;
    //UINT    uPktLen;
    int i;

    PSPingPongData    pPPD;
    PSProtocolBuffer  pProBuf;

    pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];
    //uPktLen = sizeof(SEthernetHeader) + sizeof(SPingPongData);
    //if (uPktLen < sizeof(SEthernetHeader) + sizeof(SPingPongData))
    //    uPktLen = sizeof(SEthernetHeader) + sizeof(SPingPongData);

    //pbyPacket = (PBYTE)malloc(uPktLen);
    pbyPacket = (PBYTE)abyPacket;


    if (pbyPacket == NULL)
        return FALSE;

    //Fill pkt data
    switch (iDataPat) {
    case PKT_DATA_ZERO:
        MEMvSet((PVOID)pbyPacket, (BYTE)0x00, uPktLen);
        break;

    case PKT_DATA_ALLFF:
        MEMvSet((PVOID)pbyPacket, (BYTE)0xFF, uPktLen);
        break;

    case PKT_DATA_55AA:
        for (i=0; i<uPktLen; i++) {
            if (i%2 == 0)
                *(pbyPacket+i) = 0x55;
            else
                *(pbyPacket+i) = 0xAA;
        }
        break;

    case PKT_DATA_RANDOM: {
        UINT    uPosition;

        // RANDOM DATA
        // Get random position in Random Table
        /*uPosition = RANDOM((3072 - uPktLen));*/
		/*no rand() use tmpt_rand() to replace*/
		uPosition = (UINT)(((UINT)tmpt_rand()*(3072 - uPktLen)) / (UINT)(32767+1));
		
        for (i = 0; i < uPktLen; i++) {
            *(pbyPacket + i) = *((PBYTE)sg_abyRandomTable + uPosition + i);
        }

        }
        break;

    default:
        break;
    }

    pPPD = (PSPingPongData)(pbyPacket + sizeof(SEthernetHeader));
    pPPD->dwSerialNo = pProBuf->dwSerialNo;
    pProBuf->dwSerialNo++;
    GPPTvMakeEthernetPacket(pbyPacket, pProBuf->abyDstAddr, 
                           pAdapter->abyEtherAddr,
                           TYPE_PKT_PING_M, (PBYTE)pPPD);

    if (!GPRObDriverSend(pAdapter, pbyPacket, uPktLen, 0))
        goto MPErr;

    //free(pbyPacket);
    return TRUE;

MPErr:
    //free(pbyPacket);
    return FALSE;
}


BOOL GPPTbMasterDisConn(PSAdapterInfo pAdapter)
{
    PBYTE   pbyPacket;
    UINT    uPktLen;

    PSPingPongData    pPPD;
    PSProtocolBuffer  pProBuf;


    pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];
    uPktLen = sizeof(SEthernetHeader) + sizeof(SPingPongData);
    pbyPacket = (PBYTE)malloc(uPktLen);

    if (pbyPacket == NULL)
        return FALSE;

    pPPD = (PSPingPongData)(pbyPacket + sizeof(SEthernetHeader));
    pPPD->dwSerialNo = pProBuf->dwSerialNo;
    pProBuf->dwSerialNo++;
    GPPTvMakeEthernetPacket(pbyPacket, pProBuf->abyDstAddr, 
                           pAdapter->abyEtherAddr,
                           TYPE_PKT_DISCONN_M, (PBYTE)pPPD);

    if (!GPRObDriverSend(pAdapter, pbyPacket, uPktLen, 0))
        goto MPErr;

    free(pbyPacket);
    return TRUE;

MPErr:
    free(pbyPacket);
    return FALSE;
}


BOOL GPPTbMasterCheckPong(PSAdapterInfo pAdapter)
{
    BOOL    bRetVal = FALSE;
    PBYTE   pbyPacket;
    UINT    uPktLen;

    PSPingPongData   pPPD;
    PSEthernetHeader peh;
    PSProtocolBuffer pProBuf;


    pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];

    if (GPRObProtocolReceive(pAdapter, &pbyPacket, &uPktLen)) {
        peh = (PSEthernetHeader)pbyPacket;

        if (peh->wType == TYPE_PKT_PING_S) {
            pPPD = (PSPingPongData)(pbyPacket + sizeof(SEthernetHeader));
            if (pPPD->dwSerialNo != (pProBuf->dwSerialNo - 1)) {
                pAdapter->scStatistic.dwCntSerialNumErr++;
                // if master rx serial no. error, then maybe 
                // network lantency time too long, so maybe
                // have two packets in buffer, so clear buffer
                while (GPRObProtocolReceive(pAdapter, &pbyPacket, &uPktLen))
                    GPROvProtocolReturnPacket(pAdapter);
            }

            bRetVal = TRUE;
        }

        GPROvProtocolReturnPacket(pAdapter);
    }

    return bRetVal;
}


BOOL GPPTbSlaveGrant(PSAdapterInfo pAdapter, WORD wType)
{
    PBYTE   pbyPacket;
    UINT    uPktLen;

    PSPingPongData    pPPD;
    PSProtocolBuffer  pProBuf;


    pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];
    uPktLen = sizeof(SEthernetHeader) + sizeof(SPingPongData);
    pbyPacket = (PBYTE)malloc(uPktLen);

    if (pbyPacket == NULL)
        return FALSE;

    pPPD = (PSPingPongData)(pbyPacket + sizeof(SEthernetHeader));
    // TBD.... do something with pPPD
    GPPTvMakeEthernetPacket(pbyPacket, pProBuf->abyDstAddr,
                           pAdapter->abyEtherAddr,
                           wType, (PBYTE)pPPD);

    if (!GPRObDriverSend(pAdapter, pbyPacket, uPktLen, 0))
        goto SGErr;

    free(pbyPacket);
    return TRUE;

SGErr:
    free(pbyPacket);
    return FALSE;
}


BOOL GPPTbSlaveCheckPingAndPongBack(PSAdapterInfo pAdapter)
{
    BOOL    bRetVal = FALSE;
    PBYTE   pbyPacket;
    UINT    uPktLen;

    PSPingPongData   pPPD;
    PSEthernetHeader peh;
    PSProtocolBuffer pProBuf;


    pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];

    if (GPRObProtocolReceive(pAdapter, &pbyPacket, &uPktLen)) {
        peh = (PSEthernetHeader)pbyPacket;

        if (peh->wType == TYPE_PKT_PING_M) {
            pPPD = (PSPingPongData)(pbyPacket + sizeof(SEthernetHeader));
            if (pPPD->dwSerialNo != pProBuf->dwSerialNo)
                pAdapter->scStatistic.dwCntSerialNumErr++;

            pProBuf->dwSerialNo = (pPPD->dwSerialNo + 1);

            GPPTvMakeEthernetPacket(pbyPacket, pProBuf->abyDstAddr, 
                                   pAdapter->abyEtherAddr,
                                   TYPE_PKT_PING_S, (PBYTE)pPPD);
            if (GPRObDriverSend(pAdapter, pbyPacket, uPktLen-4, 0)) //remove CRC
                bRetVal = TRUE;
        }

        GPROvProtocolReturnPacket(pAdapter);
    }

    return bRetVal;
}


BYTE GPPTbySlaveCheckPingAndPongBackEx(PSAdapterInfo pAdapter)
{
    BYTE    byRetVal = FALSE;
    PBYTE   pbyPacket;
    UINT    uPktLen;

    PSPingPongData   pPPD;
    PSEthernetHeader peh;
    PSProtocolBuffer pProBuf;


    pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];

    if (GPRObProtocolReceive(pAdapter, &pbyPacket, &uPktLen)) {
        peh = (PSEthernetHeader)pbyPacket;

        if (peh->wType == TYPE_PKT_PING_M) {
            pPPD = (PSPingPongData)(pbyPacket + sizeof(SEthernetHeader));
            if (pPPD->dwSerialNo != pProBuf->dwSerialNo)
                pAdapter->scStatistic.dwCntSerialNumErr++;

            pProBuf->dwSerialNo = (pPPD->dwSerialNo + 1);

            GPPTvMakeEthernetPacket(pbyPacket, pProBuf->abyDstAddr, 
                                   pAdapter->abyEtherAddr,
                                   TYPE_PKT_PING_S, (PBYTE)pPPD);
            if (GPRObDriverSend(pAdapter, pbyPacket, uPktLen-4, 0)) //remove CRC
                byRetVal = TRUE;
        }
        else if (peh->wType == TYPE_PKT_DISCONN_M) { 
            byRetVal = 0xFF;
        } 

        GPROvProtocolReturnPacket(pAdapter);
    }

    return byRetVal;
}

