


#ifndef __MEM_H__
#define __MEM_H__


#if !defined(__TTYPE_H__)
#include "ttype.h"
#endif


/*---------------------  Export Definitions -------------------------*/
/* memory allocation map from RAW(allocated) memory -> ALIGNED memory */
typedef struct tagSAllocMap {
    /* this dwRawSize value must assign */
    DWORD   dwRawSize;                  /* allocated size  of the memory block */
    DWORD   dwRawVAddr;                 /* allocated virtual address of the memory block */
    QWORD   qwRawPAddr;                 /* allocated physical address of the memory block */
    DWORD   dwSize;                     /* aligned size (exactly) */
    DWORD   dwVAddr;                    /* aligned virtual address */
    DWORD   dwPAddr;                    /* aligned physical address */

    PVOID   pvHandle;                   /* handle to do system-call */

} SAllocMap, *PSAllocMap;

/*---------------------  Export Types  ------------------------------*/

/*---------------------  Export Macros ------------------------------*/

/*---------------------  Export Classes  ----------------------------*/

/*---------------------  Export Variables  --------------------------*/

/*---------------------  Export Functions  --------------------------*/
#ifdef __cplusplus
extern "C" {                            /* Assume C declarations for C++ */
#endif /* __cplusplus */

VOID
MEMvAlign(
    PSAllocMap pamMem,
    UINT    uBoundary
    );

PVOID
MEMvAllocate(
    UINT    uCount
    );

VOID
MEMvAllocateShared(
    PSAllocMap pamMem
    );

VOID
MEMvCopy(
    PVOID   pvDst,
    PVOID   pvSrc,
    UINT    uCount
    );

VOID
MEMvSet(
    PVOID   pvDst,
    BYTE    byPattern,
    UINT    uCount
    );

#ifdef __cplusplus
}                                       /* End of extern "C" { */
#endif /* __cplusplus */

#endif /* __MEM_H__ */
