


#if !defined(__UMEM_H__)
#include "tmem.h"
#endif

#if !defined(__TBIT_H__)
#include "tbit.h"
#endif
#if !defined(__TCRC_H__)
#include "tcrc.h"
#endif
#if !defined(__MAC_H__)
#include "mac.h"
#endif
#if !defined(__GISR_H__)
#include "gisr.h"
#endif
#if !defined(__PROTO_H__)
#include "proto.h"
#endif



/*---------------------  Static Definitions -------------------------*/

/*---------------------  Static Classes  ----------------------------*/

/*---------------------  Static Variables  --------------------------*/

/*---------------------  Static Functions  --------------------------*/

/*---------------------  Export Variables  --------------------------*/
SProtocolBuffer sg_aGProBuf[MAX_NET_DEVICE];

/*---------------------  Export Functions  --------------------------*/
void CALLBACK GISRvCopyDescBufToProBuf (PSAdapterInfo pAdapter, PBYTE pbyBuffer, UINT cbLength)
{
    int     idxCurrBuf;
    PSProtocolBuffer pProBuf;

    pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];
    idxCurrBuf = pProBuf->idxRxBufHead;
    if (!pProBuf->abRxBufOccupied[idxCurrBuf]) {
        //printf("length:%d %2x %2x %2x %2x %2x\n",cbLength,*pbyBuffer,*(pbyBuffer+1),*(pbyBuffer+2),*(pbyBuffer+3),*(pbyBuffer+4));
        pProBuf->auRxBufLength[idxCurrBuf] = cbLength;
        MEMvCopy((PVOID)pProBuf->apbyRxBuffer[idxCurrBuf], (PVOID)pbyBuffer, cbLength);
        pProBuf->abRxBufOccupied[idxCurrBuf] = TRUE;

        // move index
		if (pProBuf->idxRxBufHead >= pAdapter->cbRD - 1)
            pProBuf->idxRxBufHead = 0;
        else
            pProBuf->idxRxBufHead++;

    }
}

BOOL GPRObDriverSend(PSAdapterInfo pAdapter, PBYTE pbyPacket, UINT uPktLen, BYTE byTxQue)
{
    PBYTE     pbyTxDescBuffer;
    UINT      uCurrTdIdx;
    PSTxDesc  pTD;
    WORD      ww;

     //printf("send start\n");
    uCurrTdIdx = pAdapter->uTxEnqueDescIdx[byTxQue];
    pTD = pAdapter->aapTD[byTxQue][uCurrTdIdx];

    // if tx queue is full
    if (pTD->m_td0TD0.f1Owner == B_OWNED_BY_CHIP)
        return FALSE;

    // copy buffer
    //pbyTxDescBuffer = (PBYTE)(pAdapter->aaamTxDescBufPool[byTxQue][0].dwVAddr + wCurrTdIdx*CB_MAX_BUF_SIZE);
    pbyTxDescBuffer = (PBYTE)(pAdapter->aapTD[byTxQue][uCurrTdIdx]->m_asTxBufs[0].dwTxBufAddrLo);
    MEMvCopy((PVOID)pbyTxDescBuffer, (PVOID)pbyPacket, uPktLen);

    if (uPktLen < MIN_PACKET_LEN)
        uPktLen = MIN_PACKET_LEN;

    // Set TD PktLen
    pTD->m_td0TD0.f14TxPktSize = (WORD)uPktLen;

    // set up data segment
    pTD->m_td1TD1.f4CMDZ = 2;
    pTD->m_asTxBufs[0].f14TxBufSize = (WORD)uPktLen;

    //
    // Set Qwner Bit and Que Bit
    //
    // Get Last TdIdx
    UINT    uLastTdIdx = (uCurrTdIdx + pAdapter->cbTD - 1) % pAdapter->cbTD;

    // Set last Td's que bit
    if (pAdapter->aapTD[byTxQue][uLastTdIdx]->m_td0TD0.f1Owner == B_OWNED_BY_CHIP) {
        //VT3119A0
        //vSetBit((PDWORD)(pAdapter->aapTD[byTxQue][uLastTdIdx]));
        //VT3119A1
        pAdapter->aapTD[byTxQue][uLastTdIdx]->m_asTxBufs[0].f1Que = B_TD_LIST_NOT_END;
    }

    // set tx descriptors owner to chip
    pTD->m_td0TD0.f1Owner = B_OWNED_BY_CHIP;

    // post one TD
    pAdapter->auTxPktPosted[byTxQue]++;

    // Move EnqueTdIdx to next
    pAdapter->uTxEnqueDescIdx[byTxQue] = (WORD)((uCurrTdIdx + 1) % pAdapter->cbTD);

    // TX
    MACvTxOn(pAdapter->dwIoBase);
    MACvTxQueueRUN(pAdapter->dwIoBase, byTxQue);
    MACvTxQueueWake(pAdapter->dwIoBase, byTxQue);
	
    // W_MAX_TIMEOUT is the timeout period
	/*
    for (ww = 0; ww < W_MAX_TIMEOUT; ww++) {
        if (pAdapter->auTxPktPosted[byTxQue] == 0)
            break;
        PCAvDelayByIO(CB_DELAY_LOOP_WAIT);
    }
	
    if (ww == W_MAX_TIMEOUT)
        return FALSE;
	*/
	//printf("send end\n");
    return TRUE;
}


BOOL GPRObDriverSendEx (
    PSAdapterInfo   pAdapter,
    BYTE            byTxQue,
    WORD            wVID,
    BYTE            byPri,
    BYTE            byHwOpt,
    PBYTE           pbyPacket,
    UINT            uPktLen
    )
{
    PBYTE     pbyTxDescBuffer;
    UINT      uCurrTdIdx;
    PSTxDesc  pTD;
    WORD      ww;

    uCurrTdIdx = pAdapter->uTxEnqueDescIdx[byTxQue];
    pTD = pAdapter->aapTD[byTxQue][uCurrTdIdx];

    // if tx queue is full
    if (pTD->m_td0TD0.f1Owner == B_OWNED_BY_CHIP)
        return FALSE;

    // copy buffer
    //pbyTxDescBuffer = (PBYTE)(pAdapter->aaamTxDescBufPool[byTxQue][0].dwVAddr + wCurrTdIdx*CB_MAX_BUF_SIZE);
    pbyTxDescBuffer = (PBYTE)(pAdapter->aapTD[byTxQue][uCurrTdIdx]->m_asTxBufs[0].dwTxBufAddrLo);
    MEMvCopy((PVOID)pbyTxDescBuffer, (PVOID)pbyPacket, uPktLen);

    if (uPktLen < MIN_PACKET_LEN)
        uPktLen = MIN_PACKET_LEN;

    // Set TD PktLen
    pTD->m_td0TD0.f14TxPktSize = (WORD)uPktLen;

    // set up data segment
    pTD->m_td1TD1.f4CMDZ = 2;
    pTD->m_asTxBufs[0].f14TxBufSize = (WORD)uPktLen;

    // set up TD
    pTD->m_td1TD1.byTCR0 |= byHwOpt;
    pTD->m_td1TD1.f12VID=wVID;
    pTD->m_td1TD1.f3Prioity=byPri;

    //
    // Set Qwner Bit and Que Bit
    //
    // Get Last TdIdx
    UINT    uLastTdIdx = (uCurrTdIdx + pAdapter->cbTD - 1) % pAdapter->cbTD;

    // Set last Td's que bit
    if (pAdapter->aapTD[byTxQue][uLastTdIdx]->m_td0TD0.f1Owner == B_OWNED_BY_CHIP) {
        //VT3119A0
        //vSetBit((PDWORD)(pAdapter->aapTD[byTxQue][uLastTdIdx]));
        //VT3119A1
        pAdapter->aapTD[byTxQue][uLastTdIdx]->m_asTxBufs[0].f1Que = B_TD_LIST_NOT_END;
    }

    // set tx descriptors owner to chip
    pTD->m_td0TD0.f1Owner = B_OWNED_BY_CHIP;

    // post one TD
    pAdapter->auTxPktPosted[byTxQue]++;

    // Move EnqueTdIdx to next
    pAdapter->uTxEnqueDescIdx[byTxQue] = (WORD)((uCurrTdIdx + 1) % pAdapter->cbTD);

    // TX
    MACvTxOn(pAdapter->dwIoBase);
    MACvTxQueueRUN(pAdapter->dwIoBase, byTxQue);
    MACvTxQueueWake(pAdapter->dwIoBase, byTxQue);

    // W_MAX_TIMEOUT is the timeout period
    for (ww = 0; ww < W_MAX_TIMEOUT; ww++) {
        if (pAdapter->auTxPktPosted[byTxQue] == 0)
            break;
        PCAvDelayByIO(CB_DELAY_LOOP_WAIT);
    }
    if (ww == W_MAX_TIMEOUT)
        return FALSE;

    return TRUE;
}

BOOL GPRObProtocolReceive(PSAdapterInfo pAdapter, PBYTE* ppbyPacket, PUINT puPktLen)
{
	int     idxCurrBuf;
	PSProtocolBuffer pProBuf;
	
	pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];
	idxCurrBuf = pProBuf->idxRxBufTail;
	//idxCurrBuf = pAdapter->uRxDequeDescIdx;
	//pAdapter->bTmpt = TRUE;
	//gmac_receive();
	//pAdapter->bTmpt = FALSE;
	// no packet in buffer, so rx from net side
	if (!pProBuf->abRxBufOccupied[idxCurrBuf]) {
		pAdapter->bTmpt = TRUE;
		gmac_receive();
		pAdapter->bTmpt = FALSE;
		return FALSE;
	}
	else {
		//printf("tmpt test\n");
		*ppbyPacket = pProBuf->apbyRxBuffer[idxCurrBuf];
		*puPktLen = pProBuf->auRxBufLength[idxCurrBuf];
		//pProBuf->abRxBufOccupied[idxCurrBuf] = FALSE;
	}

	return TRUE;
}


VOID GPROvProtocolReturnPacket(PSAdapterInfo pAdapter)
{
    int     idxCurrBuf;
    PSProtocolBuffer pProBuf;


    pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];
    idxCurrBuf = pProBuf->idxRxBufTail;
    if (pProBuf->abRxBufOccupied[idxCurrBuf]) {

        pProBuf->abRxBufOccupied[idxCurrBuf] = FALSE;

        // move index
        if (pProBuf->idxRxBufTail >= pAdapter->cbRD - 1)
            pProBuf->idxRxBufTail = 0;
        else
            pProBuf->idxRxBufTail++;
    }
}


BOOL GPRObProtocolConstruct(PSAdapterInfo pAdapter)
{
    int ii;
    PSProtocolBuffer pProBuf;


    pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];
    pProBuf->idxRxBufHead = 0;
    pProBuf->idxRxBufTail = 0;

    for (ii = 0; ii < pAdapter->cbRD; ii++) {        
        pProBuf->apbyRxBuffer[ii] = (PBYTE)malloc(2048);
        if (pProBuf->apbyRxBuffer[ii] == NULL)
            return FALSE;
        pProBuf->abRxBufOccupied[ii] = FALSE;
    }
    // enable protocol layer
    pAdapter->pisrPptReceiver = (void (*)(void))GISRvCopyDescBufToProBuf;
    return TRUE;
}


VOID GPROvProtocolDestruct(PSAdapterInfo pAdapter)
{
    int ii;
    PSProtocolBuffer pProBuf;


    pProBuf = &sg_aGProBuf[pAdapter->uAdapterIndex];
    // disable protocol layer
    pAdapter->pisrPptReceiver = NULL;

    for (ii = 0; ii < pAdapter->cbRD; ii++) {
        free(pProBuf->apbyRxBuffer[ii]);
    }
}

extern int tmpt_rand();
VOID GPROvPrepareTxPacketEx(
    PSAdapterInfo   pAdapter,
    BYTE            byTxQue,
    UINT            uIdx,
    UINT            uSegNum
    )
{
    UINT        i, ii;
    UINT        kk;
    PSTxDesc    ptdCurr = pAdapter->aapTD[byTxQue][uIdx]; //curr TD
    UINT        uTxPktSize;                               //Tx packet size
    PBYTE       pbyBuffer = (PBYTE)(pAdapter->aapTD[byTxQue][uIdx]->m_asTxBufs[0].dwTxBufAddrLo);


    // RANDOM packet length
    if (pAdapter->bRandomPktLength){
        //TBD random
        UINT    uRandomPktSize = (MAX_PACKET_LEN) + 1;

        // In loopback test, hardware wouldn't generate 4-byte CRC, software make
        // the minumum TX buffer size to be 64 bytes to avoid generating runt packet
        if (uRandomPktSize < (MIN_PACKET_LEN + 4)) {
            // TBD.... + CRC 4 bytes
            uRandomPktSize = MIN_PACKET_LEN + 4;
        }
        //if (uRandomPktSize > MAX_PACKET_LEN) {
        //    uRandomPktSize = MAX_PACKET_LEN;
        //}
        uTxPktSize = uRandomPktSize;
    }
    else if (pAdapter->bIncPktLength) {
        uTxPktSize = pAdapter->uTxPktSize;
    }
    else {
        //uTxPktSize = MAX_PACKET_LEN;
        uTxPktSize = pAdapter->cbPktSize;
    }

    // Set TD PktLen
    ptdCurr->m_td0TD0.f14TxPktSize = (WORD)uTxPktSize;

    //
    // Calculate each segment's buffer size
    //
    // Move from TransmitEx or TransmitSinglePacket
    if (pAdapter->bRandDatSegsPerPacket) {
        //TBD random
        uSegNum = (CB_MAX_SEG_PER_PKT) + 1;
    }
    else {
        uSegNum = pAdapter->uTxDataSegsPerPacket;
    }

    if (uSegNum > 1) {
        WORD    wTempBufSize;

        // The BufLen of first Buf is 14
        ptdCurr->m_asTxBufs[0].f14TxBufSize = 14;

        // The rest
        // Equal the buffer length
        wTempBufSize = (WORD)((uTxPktSize - 14) / (uSegNum - 1));
        for (i = 1; i < uSegNum; i++) {
            if (i == (uSegNum - 1)) {
                ptdCurr->m_asTxBufs[i].f14TxBufSize = (WORD)((uTxPktSize - 14) - (wTempBufSize*(uSegNum - 2)));
            }
            else {
                ptdCurr->m_asTxBufs[i].f14TxBufSize = wTempBufSize;
            }
            ptdCurr->m_asTxBufs[i].dwTxBufAddrLo = ptdCurr->m_asTxBufs[i-1].dwTxBufAddrLo + ptdCurr->m_asTxBufs[i-1].f14TxBufSize;
        } // end for
        for ( ; i < CB_MAX_SEG_PER_PKT; i++) {
            ptdCurr->m_asTxBufs[i].f14TxBufSize = 0;
            ptdCurr->m_asTxBufs[i].dwTxBufAddrLo = 0;
        }
    }
    else {
        // uSegNum = 1
        // only one descriptor; it occupies the whole packet size
        ptdCurr->m_asTxBufs[0].f14TxBufSize = (WORD)uTxPktSize;
        for (i = 1; i < CB_MAX_SEG_PER_PKT; i++) {
            ptdCurr->m_asTxBufs[i].f14TxBufSize = 0;
            ptdCurr->m_asTxBufs[i].dwTxBufAddrLo = 0;
        }
    } // end if (uSegNum > 1)
    ptdCurr->m_td1TD1.f4CMDZ = (BYTE)(uSegNum + 1);
    
    //
    // fill the buffer data for each data segment if needed
    //
    if (pAdapter->bRandomPktData) {

        UINT    uPosition;

        // RANDOM DATA
        // Get random position in Random Table
        //TBD random
        uPosition = ((3072 - uTxPktSize));

        for (kk = 0; kk < uTxPktSize; kk++) {
            *(pbyBuffer + kk) = *((PBYTE)sg_abyRandomTable + uPosition + kk);
        }
    }

    if (pAdapter->bIncreasePktData) {
        // INCREASE DATA
        for (ii = 0; ii < 1; ii++) {
            for (kk = 0; kk < uTxPktSize; kk++) {
                *(pbyBuffer + kk) = pAdapter->byDataIncreased++;
            }
        } // end for (ii)
    }


    //
    // set up TD control data
    //
    if (pAdapter->b8021pqTag) {
        ptdCurr->m_td1TD1.f12VID = (WORD)(tmpt_rand() & 0x0FFF);
        ptdCurr->m_td1TD1.f3Prioity = (WORD)(tmpt_rand() & 0x07);
        ptdCurr->m_td1TD1.byTCR0 |= TCR0_VETAG;
    }

    //
    // Set Qwner Bit and Que Bit
    //
    // Get Last TdIdx
    UINT    uLastTdIdx = (uIdx + pAdapter->cbTD - 1) % pAdapter->cbTD;

    // Set last Td's que bit
    if (!pAdapter->bTxSinglePacket) {
        if (pAdapter->aapTD[byTxQue][uLastTdIdx]->m_td0TD0.f1Owner == B_OWNED_BY_CHIP) {
            //VT3119A0
            //vSetBit((PDWORD)(pAdapter->aapTD[byTxQue][uLastTdIdx]));
            //VT3119A1
            pAdapter->aapTD[byTxQue][uLastTdIdx]->m_asTxBufs[0].f1Que = B_TD_LIST_NOT_END;
        }
    }

    // Set this Td's owner bit
    if (pAdapter->aapTD[byTxQue][uIdx]->m_td0TD0.f1Owner == B_OWNED_BY_HOST) {
        pAdapter->aapTD[byTxQue][uIdx]->m_td0TD0.f1Owner = B_OWNED_BY_CHIP;
    }

    // Set CRC Bit
    if (pAdapter->bSoftwareGenCrc) {
        pAdapter->aapTD[byTxQue][uIdx]->m_td1TD1.byTCR0 |= TCR0_CRC;
    }
    else {
        pAdapter->aapTD[byTxQue][uIdx]->m_td1TD1.byTCR0 &= ~TCR0_CRC;
    }


    //
    // SW GENERATE CRC
    //
    if (pAdapter->bSoftwareGenCrc) {
        // disable system interrupt to prevent context switch
        // while calculating CRC
        PCAvIntDisable();

        // calculate CRC, and wrtie CRC value to end of TD
        DWORD   dwCRC;// = 0xFFFFFFFFL;
        dwCRC = CRCdwGetCrc32(pbyBuffer, uTxPktSize - 4);

        PDWORD pdwCRC = (PDWORD)(pbyBuffer + uTxPktSize - 4);
        // finally, we must invert dwCRC to get the correct answer
        *pdwCRC = dwCRC;

        // enable interrupt
        PCAvIntEnable();
    }


    // increase packet length
    if (pAdapter->bIncPktLength) {
        pAdapter->uTxPktSize++;
        if (pAdapter->uTxPktSize > MAX_PACKET_LEN){
            pAdapter->uTxPktSize = MIN_PACKET_LEN + 4;
        }
    }

    // Move EnqueTdIdx to next
    pAdapter->uTxEnqueDescIdx[byTxQue] = (pAdapter->uTxEnqueDescIdx[byTxQue] + 1) % pAdapter->cbTD;

}

VOID GPROvDoTransmitSinglePacket (PSAdapterInfo pAdapter, BYTE byTxQue)
{
    UINT    uSegNum = 1;
    UINT    uCurrTdIdx = pAdapter->uTxEnqueDescIdx[byTxQue];

    // Prepare one TD
    GPROvPrepareTxPacketEx(pAdapter, byTxQue, uCurrTdIdx, uSegNum);

    pAdapter->auTxPktPosted[byTxQue] = 1;

    //
    // ACTION
    //
    MACvTxQueueWake(pAdapter->dwIoBase, byTxQue);
    

}


VOID GPROvDoTransmitEx(PSAdapterInfo pAdapter, BYTE byTxQue)
{
    UINT    uu;
    UINT    uSegNum = 1;

    //link to upper layer
    GPRObProtocolConstruct(pAdapter);
    
    //prepare TD
    pAdapter->auTxPktPosted[byTxQue]=0;
    pAdapter->uTxEnqueDescIdx[byTxQue] = 0;
    pAdapter->uTxDequeDescIdx[byTxQue] = 0;
    GMACvSetTqIndex(pAdapter->dwIoBase, byTxQue, 0);

    for (uu = 0; uu < pAdapter->cbTD; uu++) {

        GPROvPrepareTxPacketEx(pAdapter, byTxQue, uu, uSegNum);

        pAdapter->auTxPktPosted[byTxQue]++;
    }

    //
    // ACTION
    //
    MACvTxQueueWake(pAdapter->dwIoBase, byTxQue);

}


