

#ifndef __UASSERT_H__
#define __UASSERT_H__

#if !defined(__TTYPE_H__)
#include "ttype.h"
#endif

/*---------------------  Export Definitions -------------------------*/

/* if not define _DEBUG, then DBG_ASSERT will be null */
#ifndef _DEBUG
/* translate ASSERT(f) to empty space */
#define DBG_ASSERT(f)
#define DBG_ASSERT_VALID(f)
#else  /* _DEBUG */
/* translate ASSERT(f) to c function call */
#define DBG_ASSERT(f)
#define DBG_ASSERT_VALID(p)
#endif /* _DEBUG */

/* if (_DEBUG) then (_DEBUG_LOUD) */
#ifndef _DEBUG
#define DBG_PRN(arg)
#else  /* _DEBUG */
#define _DEBUG_LOUD
#define DBG_PRN(arg)                    {DbgPrint("***** "); DbgPrint arg ; }
#endif /* _DEBUG */

#ifndef _DEBUG_LOUD
#define DBG_PRN_LOUD(arg)
#else  /* _DEBUG_LOUD */
#define DBG_PRN_LOUD(arg)               {DbgPrint("##### "); DbgPrint arg ; }
#endif /* _DEBUG_LOUD */

#ifndef _DEBUG_PORT80
#define DBG_IMM_PORT80(handle, value)
#define DBG_PORT80(value)
#else  /* _DEBUG_PORT80 */
#define DBG_IMM_PORT80(handle, value)   NdisImmediateWritePortUchar(handle, 0x80, value);
#define DBG_PORT80(value)               NdisRawWritePortUchar(0x80, value);
#endif /* _DEBUG_PORT80 */

#ifndef _DEBUG_PORT80_ALWAYS
#define DBG_PORT80_ALWAYS(value)
#else  /* _DEBUG_PORT80_ALWAYS */
#define DBG_PORT80_ALWAYS(value)        NdisRawWritePortUchar(0x80, value);
#endif /* _DEBUG_PORT80_ALWAYS */

#ifndef _DEBUG_BREAK
#define DBG_BRK()
#else  /* _DEBUG_BREAK */
#define DBG_BRK()                       { ASM{  int 3   } }
#endif /* _DEBUG_BREAK */

/*---------------------  Export Classes  ----------------------------*/

/*---------------------  Export Variables  --------------------------*/

/*---------------------  Export Functions  --------------------------*/

#endif /* __UASSERT_H__ */
