


#ifndef __UMEM_H__
#define __UMEM_H__

#if !defined(__TTYPE_H__)
#include "ttype.h"
#endif
#if !defined(__TMEM_H__)
#include "tmem.h"
#endif




/*---------------------  Export Definitions -------------------------*/

#if	defined(__REAL_MODE)

// segment:offset types
typedef WORD            OFFSET;
typedef WORD            SEGMENT;

// macros to break C "far" pointers into their segment and offset components
#define OFFSET_OF(lp)       (*((WORD FAR*)&(lp)))
#define SEGMENT_OF(lp)      (*((WORD FAR*)&(lp)+1))
// macro to construct a far pointer from segment and offset values
#define MAKE_LP(seg, ofs)   ((void FAR*)MAKELONG((ofs), (seg)))

// macro MAKE seg:ofs into Physical address
#define MAKE_SEG_OFF_TO_PHY_ADDR(lp)        \
    (((DWORD)SEGMENT_OF(lp)) << 4) + ((DWORD)OFFSET_OF(lp))


#if !defined(MK_FP)
#define MK_FP( seg,ofs )    ( (void _seg * )( seg ) +( void near * )( ofs ))
#endif
#if !defined(FP_SEG)
#define FP_SEG( fp )        ( (unsigned )( void _seg * )( void far * )( fp ))
#endif
#if !defined(FP_OFF)
#define FP_OFF( fp )        ( (unsigned )( fp ))
#endif


#endif  // __REAL_MODE


#if defined(__WATCOMC__)
#define D32RealSeg(_P_) ((((DWORD)(_P_)) >> 4) & 0xFFFF)
#define D32RealOff(_P_) (((DWORD)(_P_)) & 0xF)
#endif



#define ZERO_MEMORY(pvDst, uCount) {       \
    MEMvSet(pvDst, 0x00, uCount);          \
}

                                                
/*---------------------  Export Classes  ----------------------------*/

/*---------------------  Export Variables  --------------------------*/

/*---------------------  Export Functions  --------------------------*/
#if defined(__cplusplus)
extern "C" {                            /* Assume C declarations for C++ */
#endif // __cplusplus


void MEMvAllocate(PVOID pvMemAddr, UINT uCount, PVOID pvRetStatus);
void MEMvFree(PVOID pvMemAddr, UINT uCount);

void MEMvAllocateShared(PSAllocMap pamMem);
void MEMvFreeShared(PSAllocMap pamMem);

void MEMvSet(PVOID pvDst, BYTE byPattern, UINT uCount);
void MEMvCopy(PVOID pvDst, PVOID pvSrc, UINT uCount);
void MEMvMove(PVOID pvDst, PVOID pvSrc, UINT uCount);

DWORD MEMdwLP2PhyAddr(PVOID pvFar);
PVOID MEMpvPhyAddr2LP(DWORD dwPhyAddr);


#if defined(__cplusplus)
}                                       /* End of extern "C" { */
#endif // __cplusplus




#endif // __UMEM_H__


