/*******************************************************************************
  Copyright (c) 2006-2007 WMT Technologies, Inc.

  Module Name:

    $Workfile: tmpt.h $

  Abstract:

  Revision History:

    $JustDate: 09/09/22 $
    $Author: Tommy Huang $

*******************************************************************************/
#ifndef __TMTP_H__
#define __TMTP_H__

//
//Dir[7] = 0 READ from Target point of view
//Dir[7] = 1 WRITE
//DevId[7:0] = 8'h00 EMAC
//DevId[7:0] = 8'h01 Nand
//DevId[7:0] = 8'h02 SPI
//DevId[7:0] = 8'h03 LPC
//DevID[7:0] = 8'h04 Mem
//
typedef struct _IOPACKET
{
	uchar	Flag;   //for whatever flags you want
	uchar	DevId;
	ushort	CmdCode;
	uchar*  srcbuff;
    uchar*  dstbuff;
    ulong   xferlen;        
	uchar	Bytes[0x40]; 
}IOPACKET,*PIOPACKET;

#define IOP_RECV            0       //Read from Host
#define IOP_SEND            0x80    //Write to Host
#define DEV_EMAC            0       //EMAC Device ID
#define DEV_NAND            1       //NAND Device ID
#define DEV_SPI             2       //SPI Device ID
#define DEV_LPC             3       //LPC Device ID
#define DEV_MM              4       //MM Device ID

#define EMAC_CONNECT_CMD    0
#define EMAC_READ_CMD       1
#define EMAC_WRITE_CMD      2
#define EMAC_INIT_CMD       3

#define NF_WRITE_KERNEL0    0
#define NF_WRITE_KERNEL1    1
#define NF_READ_KERNEL0     2
#define NF_READ_KERNEL1     3
#define NF_WRITE_RAMDISK0   4
#define NF_WRITE_RAMDISK1   5
#define NF_READ_RAMDISK0    6
#define NF_READ_RAMDISK1    7

#define SF_RECV_UBOOT       0
#define SF_SEND_UBOOT       1
#define SF_RECV_UBOOTCFG    2
#define SF_SEND_UBOOTCFG    3

#define LPC_RECV_UBOOT      0
#define LPC_SEND_UBOOT      1
#define LPC_RECV_UBOOTCFG   2
#define LPC_SEND_UBOOTCFG   3

#define MM_SEND_DIAG        0
#define MM_RECV_DIAG        1
#define MM_GO_CMD           2
#define CMD_WRITE 0
#define CMD_READ  1
#define CMD_EXE   2

void em_read_iop(PIOPACKET pIop);
void em_read_data(PIOPACKET pIop);
void em_write_data(PIOPACKET pIop);
void nf_proc_iop(PIOPACKET pIop);
void sf_proc_iop(PIOPACKET pIop);
void mm_proc_iop(PIOPACKET pIop);

#define ISUCCESS	1
#define IFAIL		0
#define IACK		0x33585A5A
#define INAK		0x3358A5A5
#define COMPLETE    0x86103358
#define PKTSZ		0x580
#define PKTNO       0x10        //The number of packet can be stored in the buffer

int 
iWrite(
    unsigned char*  buf, 
    unsigned int    len
    );

int 
iRead(
    unsigned char*  buf, 
    unsigned int    len
    );

void 
GoCmd(
    char            *src,
    char            *dst,
    unsigned long   len
    );

#define TRUE            1
#define FALSE           0

extern int connect();
extern int iSend(char* buf, int len);
extern int iRece(char* buf, int len);
extern int gmac_startio(bd_t *bd);



#endif  /* __TMTP_H__ */

