/*
 *	LiMon - BOOTP/TFTP.
 *
 *	Copyright 1994, 1995, 2000 Neil Russell.
 *	(See License)
 */

#ifndef __TFTP_H__
#define __TFTP_H__

//--> porting from VT8500 UBOOT for uploading file to tftp server (howyahuo on 20091214)
//Author: Hang Yan
#define TFTP_FILENAME_LEN	50
/****************************************** Export Types **************************************************/
struct tftp_agrument_tag
{
	char filename[TFTP_FILENAME_LEN];
	unsigned long spistartaddr; // the start address of the saved content in spi flash
	unsigned long offset; // the length of the saved content
	int optdirect; // 1 -- get file from the server;
					// 2 -- put file to the server;
	unsigned long curaddr; // the start addr which will be accessed currently
	unsigned long curlen;  // the length which will be accessed currently
};

/*
 * Brief:
 *	Set the tftp argument.
 * Input:
 *	arg -- the value should be valid.
 * Output:
 *	l_tftparg -- the static variable recording tftp argument
 * History:
 *	Created	2009-2-12
 * Author:
 * 	Hang Yan in ShenZhen.
 */
extern void set_tftparg(struct tftp_agrument_tag* arg);
//<-- end porting

/**********************************************************************/
/*
 *	Global functions and variables.
 */

/* tftp.c */
extern void	TftpStart (void);	/* Begin TFTP get */

/**********************************************************************/

#endif /* __TFTP_H__ */
